<?php
/**
* 2007-2020 PrestaShop
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
*
*  @author    IPPANEL
*  @copyright 2020 ippanel
*  @license   http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*/
//update gateway Settings
$submited = '';
if (Tools::isSubmit('gatewaysettings')) {
	$variables = array('USERNAME','PASSWORD','ADMINPHONE','SMSNUMBER','SMSSENUMBER','SMSENABLE', 'UNINSTALLDB','DEBUG','TOPMENU','LOWCREDITALERT','PANELADDRESS');
	foreach ($_POST as $key => $value) {
		if (!in_array($key, $variables)) {
			continue;
		}
		//if($key == 'PASSWORD' && $value == '') continue;
		if (!Configuration::updateValue($this->prefix . $key, trim($value))) {
			$errors[] = Tools::displayError($this->l('Settings is not updated!'));
			break;
		}
	}
	$submited = 'gatewaysettings';
	if (isset($errors) && count($errors)) {
		$this->context->cookie->redirect_errors = implode('<br />', $errors);
	} else {
		$this->context->cookie->redirect_success_message = $this->l('Settings updated.');
	}
	$submited = 'gatewaysettings';
	Tools::redirect($this->moduleSubpageUrl($submited));
	//Reset panel authentication
}elseif (Tools::isSubmit('RESETPANELAUTH')) {
	$param = array('op'=>'credit');
	$connectpanel = $this -> connectWebservice($param);
	if ($connectpanel[0] == 0) {
		$authCache = array(
			'ok' => 'user',
			'credit' => round($connectpanel[1]),
			'expireTime' => $this -> panelExpireTime(),
			'lines' => $this -> panelLines(),
			'updateTime' => time(),
		);
		Configuration::updateValue($this->prefix . 'PANELAUTH' , serialize($authCache));
	}
	$submited = 'gatewaysettings';
	Tools::redirect($this->moduleSubpageUrl($submited));
	//update Prepared sms Settings
} elseif (Tools::isSubmit('preparedsms')) {
	if (!$this->addPreparedSMSText(Tools::getValue('preparedSmsText'))) {
			$errors[] = Tools::displayError($this->l('The message is not saved!'));
		}
	if (isset($errors) && count($errors)) {
		$this->context->cookie->redirect_errors = implode('<br />', $errors);
	} else {
		$this->context->cookie->redirect_success_message = $this->l('Settings updated.');
	}
	$submited = 'preparedsms';
	Tools::redirect($this->moduleSubpageUrl($submited));	
} elseif (Tools::isSubmit('alertssettings')) {
	$variables = array(
		'NEWORDERA',
		'NEWORDERC',
		'UPDATEORDERC',
		'NEWCUSTOMERA',
		'NEWCUSTOMERC',
		'NEWORDERFC' ,
		'NEWORDERFA',
		'NEWADDMOBILE',
		'OUTOFSTOCK',
		'OUTOFSTOCKTHRESHOLD',
		'ORDERTRACKING',
		'ORDERMOBILE',
		'GUESTINVOICE',
		'ADMININVOICE',
		'SHORTINVOICEKEY',
		'SHOPNAME',
		'CRONJOB',
		'CRONITEMS',
	);
	foreach ($_POST as $key => $value) {
		if (!in_array($key, $variables)) {
			continue;
		}
		if (!Configuration::updateValue($this->prefix . $key, trim($value))) {
			$errors[] = Tools::displayError($this->l('Settings is not updated!'));
			break;
		}
	}
	Configuration::updateValue($this->prefix . 'INVOICE_NEWORDER', Tools::getIsset('INVOICE_NEWORDER') ? 1 : 0);
	Configuration::updateValue($this->prefix . 'INVOICE_UPDATEORDER', Tools::getIsset('INVOICE_UPDATEORDER') ? 1 : 0);
	Configuration::updateValue($this->prefix . 'INVOICE_UPDATETRACKING', Tools::getIsset('INVOICE_UPDATETRACKING') ? 1 : 0);
	Configuration::updateValue($this->prefix . 'CRON_newacount', Tools::getIsset('CRON_newacount') ? 1 : 0);
	Configuration::updateValue($this->prefix . 'CRON_neworder', Tools::getIsset('CRON_neworder') ? 1 : 0);
	Configuration::updateValue($this->prefix . 'CRON_updateorder', Tools::getIsset('CRON_updateorder') ? 1 : 0);
	Configuration::updateValue($this->prefix . 'CRON_updateOrderTracking', Tools::getIsset('CRON_updateOrderTracking') ? 1 : 0);
	Configuration::updateValue($this->prefix . 'CRON_newaddress', Tools::getIsset('CRON_newaddress') ? 1 : 0);
	Configuration::updateValue($this->prefix . 'CRON_outofstock', Tools::getIsset('CRON_outofstock') ? 1 : 0);
	Configuration::updateValue($this->prefix . 'CRON_manual', Tools::getIsset('CRON_manual') ? 1 : 0);
	Configuration::updateValue($this->prefix . 'CRON_allcustomers', Tools::getIsset('CRON_allcustomers') ? 1 : 0);	
	if (isset($errors) && count($errors)) {
		$this->context->cookie->redirect_errors = implode('<br />', $errors);
	} else {
		$this->context->cookie->redirect_success_message = $this->l('Settings updated.');
	}
	$submited = 'alertssettings';
	Tools::redirect($this->moduleSubpageUrl($submited));

} elseif (Tools::isSubmit('smstexts')) {
	$variables = array(
	'NEWACADTETYPE',
	'NEWACADTEXT',
	'NEWACCUTETYPE',
	'NEWACCUTEXT',
	'NEWORADTETYPE',
	'NEWORADTEXT',
	'NEWORCUTETYPE',
	'NEWORCUTEXT',
	'UPORCUTETYPE',
	'UPORCUTEXT',
	'UPORTRTETYPE',
	'UPORTRTEXT',
	'NEWADDRTETYPE',
	'NEWADDRTEXT',
	'OUTOFSTOCKTETYPE',
	'OUTOFSTOCKTEXT',
	);
	foreach ($_POST as $key => $value) {
		if (!in_array($key, $variables)) {
			continue;
		}
		if (!Configuration::updateValue($this->prefix . $key, trim($value))) {
			$errors[] = Tools::displayError($this->l('Settings is not updated!'));
			break;
		}
	}
	if (isset($errors) && count($errors)) {
		$this->context->cookie->redirect_errors = implode('<br />', $errors);
	} else {
		$this->context->cookie->redirect_success_message = $this->l('Settings updated.');
	}
	$submited = 'smstexts';
	Tools::redirect($this->moduleSubpageUrl($submited));
	//send sms
} elseif (Tools::isSubmit('sendsms')) {
	$text = Tools::getValue('SENDONETEXT');
	$phones = Tools::getValue('RECIVER');
	$sender = Tools::getValue('SMSNUMBER');
	if (Tools::isEmpty($text)) {
		$errors[]=Tools::displayError($this->l('Text is empty'));
	}elseif (Tools::isEmpty($sender)) {
		$errors[]=Tools::displayError($this->l('Sender is empty'));
	}elseif (Tools::strlen($phones)<10) {
		$errors[] = Tools::displayError($this->l('insert valid phone number'));
	} else {
		$result=$this->sendOne($text, $phones, '-', '-', $this->l('Send SMS Manual'));
		if ($result !='sent') {
			$errors[]=Tools::displayError($result);
		}
	}
	if (isset($errors) && count($errors)) {
		$this->context->cookie->redirect_errors = implode('<br />', $errors);
	} else {
		$this->context->cookie->redirect_success_message = $this->l('The sms sent.');
	}
	$submited = 'sendsms';
	Tools::redirect($this->moduleSubpageUrl($submited));
	// send to all customers
} elseif (Tools::isSubmit('sendtoall')) {
	$text = Tools::getValue('SENDALLTEXT');
	$sender = Tools::getValue('SENTOALLSENDERLINE');
	$delay = Tools::getValue('SENTOALLDELAYTIME');
	$peronce = Tools::getValue('SENTOALLPERONCE');
	$between = Tools::getValue('SENTOALLBETWEENTIME');
	if (Tools::isEmpty($text)) {
		$errors[]=Tools::displayError($this->l('Text is empty'));
	}elseif (Tools::isEmpty($sender)) {
		$errors[]=Tools::displayError($this->l('Sender is empty'));
	}else{
		$phones=$this->getPhoneMobiles();
		if($peronce){
			$phonesArrayofArray = array_chunk(explode(';',$phones),$peronce);
			foreach($phonesArrayofArray as $phonesArray){
				$phones = implode(';',$phonesArray);
				$result=$this->sendOne($text, $phones, $this->l('multiple'), '-', $this->l('Send Customers'));
				$_POST['SENTOALLDELAYTIME'] += $between;
				if ($result !='sent') {
					$errors[]=Tools::displayError($result);
				}
			}

		}else{
			$result=$this->sendOne($text, $phones, $this->l('multiple'), '-', $this->l('Send Customers'));
			if ($result !='sent') {
				$errors[]=Tools::displayError($result);
			}
		}
	}
	if (isset($errors) && count($errors)) {
		$this->context->cookie->redirect_errors = implode('<br />', $errors);
	} else {
		$this->context->cookie->redirect_success_message = $this->l('The sms sent to customers.');
	}
	$submited = 'sendtoall';
	Tools::redirect($this->moduleSubpageUrl($submited));
	// sent sms list page
} elseif (Tools::isSubmit('sentsms')) {
	$variables = array(
		'ShowSentSMScustomer',
		'ShowSentSMSorder',
		'ShowSentSMSposition',
		'ShowSentSMStime',
		'ShowSentSMSstatus',
		'ShowSentSMSbulk',
		'ShowSentSMSshop',
		'ShowSentSMSduration',
	);
	foreach ($_POST as $key => $value) {
		if (!in_array($key, $variables)) {
			continue;
		}
		if (!Configuration::updateValue($this->prefix . $key, trim($value))) {
			$errors[] = Tools::displayError($this->l('Settings is not updated!'));
			break;
		}
	}
	if (isset($errors) && count($errors)) {
		$this->context->cookie->redirect_errors = implode('<br />', $errors);
	} else {
		$this->context->cookie->redirect_success_message = $this->l('Settings updated.');
	}
	$submited = 'sentsms';
	Tools::redirect($this->moduleSubpageUrl($submited));
}